<template>
  <div class="player-container">
    <!-- The audio player. Warning: -->
    <!-- Changing musical time will not affect player -->
    <!-- You need to call setTime -->
    <div v-if="audio" class="ma-3">
      <dez-fab
        :disabled="currentTime ? currentTime <= startSecond : true"
        :tooltip="$t('player.start-again')"
        tooltip-direction="left"
        color="accent"
        icon="mdi-skip-previous"
        @click="goToStart"
      />
      <dez-fab
        tooltip-direction="left"
        color="accent"
        :tooltip="$t(
          isFinished
            ? 'player.reset'
            : playing
              ? 'player.stop' : 'player.start'
        )"
        :icon="
          isFinished
            ? 'mdi-refresh'
            : playing
              ? 'mdi-pause' : 'mdi-play'
        "
        @click="togglePlaying"
      />
    </div>
    <template v-if="audio">
      <!-- useFile is true if no youtube id is available, or if there was a youtube error -->
      <file-player
        v-if="useFile"
        ref="player"
        v-model="playing"
        :audio="audio"
        :current-time.sync="currentTime"
        @error="onFileError"
        @go-to-next="goToNext"
        @ended="setFinished"
      />
      <youtube-player
        v-else
        ref="player"
        v-model="playing"
        :audio="audio"
        :current-time.sync="currentTime"
        :last-onset.sync="lastOnsetBeforeSwitch"
        :start-second="startSecond"
        @error="onYtError"
        @go-to-next="goToNext"
        @ended="setFinished"
      />
    </template>
  </div>
</template>
<script lang="ts">
import {
  Component, VModel, PropSync, Watch, Mixins, Prop,
} from 'vue-property-decorator';
import type { Onset, Second } from '@/data';
import DezFab from '@/vuejs/components/utils/DezFab.vue';
import { Debounce } from 'vue-debounce-decorator';
import FilePlayer from './FilePlayer.vue';
import YoutubePlayer from './YoutubePlayer.vue';
import type IPlayerContainer from './IPlayerContainer';
import { warnAudioFileError, warnYoutubeError } from '../dialogs';
import MusicalTimeHandlingMixin from '../mixins/MusicalTimeHandlingMixin';

const DEBOUNCE_TIME = 2000;

@Component({
  components: {
    FilePlayer,
    YoutubePlayer,
    DezFab,
  },
})
export default class PlayerContainer
  extends Mixins(MusicalTimeHandlingMixin)
  implements IPlayerContainer {
  @PropSync('clean')
  isClean!: boolean;

  @PropSync('lastOnset')
  lastOnsetBeforeSwitch!: Onset;

  @Prop({ required: false, default: 0, type: Number })
  startSecond!: number;

  lastTime: Second | null = null;

  useFile = false;

  isFinished = false;

  created() {
    this.onAudioChange();
  }

  mounted() {
    if (this.$store.state.allowedToPlay) this.togglePlaying();
  }

  @Watch('audio')
  onAudioChange() {
    if (!this.audio) return;

    this.useFile = !this.audio.youtubeId;
  }

  @Debounce(DEBOUNCE_TIME)
  async goToNext() {
    if (!this.$store.state.corpusId) return;
    if (this.$store.state.indexCurrentPiece >= this.$store.state.corpus.length - 1) return;
    if (!this.isClean) return;

    this.$store.dispatch('updateIndexCurrentPiece', {
      indexCurrentPiece: this.$store.state.indexCurrentPiece + 1,
    });
    this.$store.dispatch('updateAllowedToPlay', {
      allowedToPlay: localStorage.getItem('continuePlaying'),
    });

    this.$router.push(this.$store.state
      .corpus[this.$store.state.indexCurrentPiece]
      .path.split('/').pop());
  }

  onYtError(e: Error) {
    // eslint-disable-next-line no-console
    console.error('Could not load youtube: ', e);

    // If file url is available, switch to it
    if (this.audio?.url) this.useFile = true;
    // Otherwise warn user
    else warnYoutubeError();
  }

  onFileError(e: Error) {
    // eslint-disable-next-line no-console
    console.error('Could not load audio file: ', e);
    warnAudioFileError();
  }

  public setRealTime(second: Second) {
    this.player?.setCurrentTime(second);
  }

  public goToStart() {
    this.setRealTime(this.startSecond as Second);
  }

  public reset() {
    this.realTimeSync = null;
    this.musicalTimeSync = null;
    this.playing = false;
    this.player?.reset();
    this.isFinished = false;
  }

  setFinished() {
    this.isFinished = true;
  }

  togglePlaying() {
    if (this.isFinished) {
      this.isFinished = false;
      this.setMusicalTime(0 as Onset);
    }
    this.playing = !this.playing;
  }

  @VModel({ default: false })
  playing!: boolean;
}
</script>
<style scoped lang="scss">
.player-container {
  display: flex;
}
</style>
